library fields.model;

import 'dart:async';
import 'dart:collection';
import 'dart:mirrors';
import 'package:tags/tags.dart';

part 'src/model/default_editors.dart';
part 'src/model/field.dart';
part 'src/model/field_editor.dart';
part 'src/model/field_list.dart';
part 'src/model/meta.dart';
part 'src/model/mirrors.dart';
part 'src/model/value_transform.dart';

void registerDefaultFieldEditors() {  
  if (!FieldEditor.isDefaultRegistered)
    FieldEditor.registerDefault(DefaultEditor);  
  if (!FieldEditor.isRegistered(bool)) 
    FieldEditor.register(bool, BoolEditor);
  if (!FieldEditor.isRegistered(DateTime))
    FieldEditor.register(DateTime, DateTimeEditor);
  if (!FieldEditor.isRegistered(num))
    FieldEditor.register(num, NumberEditor);
}

void registerDefaultValueTransforms() {  
  ValueTransform.register(const ValueTransform<int, num>(_int2num));
  ValueTransform.register(const ValueTransform<num, int>(_num2int));
  ValueTransform.register(const ValueTransform<String, int>(_string2int));
  ValueTransform.register(const ValueTransform<String, double>(_string2double));
}
