part of fields.view;

class FieldView extends HtmlElement {  
  
  static const TAG = 'field-view';
  
  final FieldListView _listView = new FieldListView();  
  ToggleButton _toggle;
  
  Field _field;
  Field get field => _field;
  
  FieldEditor _editor;  
  bool get _isExpanded => _toggle.isDown;
  
  factory FieldView(Field field) {    
    final FieldView fv = new Element.tag(TAG);
    fv._initialize(field);
    return fv;
  }
  
  FieldView.created() : super.created() {}
  
  void _initialize(Field field) {
    
    _field = field;
    _editor = new FieldEditor.forField(_field);
    
    children(this, () {
      _toggle = toggleButton(() {
        span()..innerHtml = '&#9655;'..classes = ['up'];
        span()..innerHtml = '&#9698;'..classes = ['down'];
      })
      ..classes.add('expander')
      ..onToggle.listen((_) => refresh());
      span(() {
        append(_editor.element);
      })
      ..classes.add('editorbox');
      append(_listView);
    });
    
    field.values.listen((_) => _refresh());
    _refresh();
  }
  
  void refresh() {
    if (_isExpanded) {
      _listView.refresh(_field.children);
    } else {
      _listView.refresh([]);
    }
    _refresh();
  }
  
  void _refresh() {
    _toggle.hidden = _field.children.isEmpty;
    _listView.hidden = !_isExpanded;    
  }
}
